--------------------------------------------------------------------------------			
-- GLOBALS
--------------------------------------------------------------------------------
Global("wtMainPanel", nil)
Global("wtTextView", nil)
Global("wtBars", {})
Global("wtTexts", {})
Global("wtPlayer1Bar", nil)
Global("wtIcon", nil)
Global("wtDanger", nil)
Global("wtUp", nil)
Global("wtDown", nil)
Global("wtCount", nil)

Global("AGRO", {})
Global("STATUS", {})
Global("TALANT", {})
Global("UNITS", {})
Global("FAK", {})

Global("DruidT", {})
Global("NecromanserT", {})

Global("MaxAgr", {})

Global("targetId", nil)
Global("LOC", nil)
Global("VISIBILITY", false)
Global("Danger", "")

Global("MAX_BAR_SIZE_X", 200)
Global("MAX_AGROLIST_COUNT", 5)
Global("SECTION_AGROLIST_NAME", "RealAgroM")
Global("DRAG_AND_DROP_ID", 888)
--------------------------------------------------------------------------------
-- STRINGS
--------------------------------------------------------------------------------
--**Warrior**
Global("abViciousSpin", {})
abViciousSpin["rus"] = " "
abViciousSpin["eng"] = "Vicious Spin"
abViciousSpin["ger"] = "Brutaler Wurf"

Global("abIncitingShot", {})
abIncitingShot["rus"] = " "
abIncitingShot["eng"] = "Inciting Shot"
abIncitingShot["ger"] = "Anstachelnder Schuss"

Global("abCruelty", {})
abCruelty["rus"] = ""
abCruelty["eng"] = "Cruelty"
abCruelty["ger"] = "Qulerei"

Global("abHack", {})
abHack["rus"] = ""
abHack["eng"] = "Hack"
abHack["ger"] = "Ergreifen"

Global("abStalwartDefense", {})
abStalwartDefense["rus"] = ""
abStalwartDefense["eng"] = "Stalwart Defense"
abStalwartDefense["ger"] = "Schtzt die Schwachen"

--**Mage**
Global("abWall", {})
abWall["rus"] = " "
abWall["eng"] = "Wall_of_Flame"
abWall["ger"] = "Feuerwand_SPAM"--(Spam because not in our gameversion atm)

--**Paladin**
Global("abCondemnation", {})
abCondemnation["rus"] = " "
abCondemnation["eng"] = "Condemnation"
abCondemnation["ger"] = "Verurteilung"

Global("abCrusaderBlow", {})
abCrusaderBlow["rus"] = " "
abCrusaderBlow["eng"] = "Crusader Blow"
abCrusaderBlow["ger"] = "Schlag des Kreuzritters"

Global("abCrusaderSeal", {})
abCrusaderSeal["rus"] = " "
abCrusaderSeal["eng"] = "Crusader Seal"
abCrusaderSeal["ger"] = " des Kreuzritters"

Global("abHeavenlyNova", {})
abHeavenlyNova["rus"] = " "
abHeavenlyNova["eng"] = "Heavenly Nova"
abHeavenlyNova["ger"] = "Himmlische Nova"

--**Summoner**
Global("stHellion", {})
stHellion["rus"] = ""
stHellion["eng"] = "Hellion"
stHellion["ger"] = "Hellion"

Global("abVampirism", {})
abVampirism["rus"] = ""
abVampirism["eng"] = "Vampirism"
abVampirism["ger"] = "Vampirismus"

Global("abHatefulBlow", {})
abHatefulBlow["rus"] = " "
abHatefulBlow["eng"] = "Hellion's Hateful Blow"
abHatefulBlow["ger"] = "Hasserfllter Schlag"

--**Strings**
Global("strName", {})
strName["rus"] = ""
strName["eng"] = "nameless"
strName["ger"] = "Namenlos"

--**Healer**
Global("abEntreaty", {})
abEntreaty["rus"] = ""
abEntreaty["eng"] = "Entreaty"
abEntreaty["ger"] = "Flehen"

Global("abAscension", {})
abAscension["rus"] = " "
abAscension["eng"] = "Ascension"
abAscension["ger"] = "Verbannung des Bsen"

--**Taunt**
Global("Intimidate", {})
Intimidate["rus"] = ""
Intimidate["ger"] = "Verspottet"
Intimidate["eng"] = "Intimidate"

Global("Challenge", {})
Challenge["rus"] = "  "
Challenge["ger"] = "Herausforderung"
Challenge["eng"] = "Challenge"

Global("Provocation", {})
Provocation["rus"] = ""
Provocation["ger"] = "Provozieren"
Provocation["eng"] = "Provocation"

--**Task**
Global( "abIcyGrave",{})
abIcyGrave["rus"] = ""
abIcyGrave["fra"] = "Tombeau de glace"
abIcyGrave["ger"] = "Eisiges Grab"
abIcyGrave["eng"] = "Icy Grave" 

Global( "abPlague",{})
abPlague["rus"] = " " 
abPlague["fra"] = "Faiblesse" 
abPlague["ger"] = "Lhmende Plage" 
abPlague["eng"] = "Debilitating Plague" 

Global( "abPotion",{})
abPotion["rus"] = " "
abPotion["eng"] = "Lethargy Potion"
abPotion["fra"] = "Potion de lethargie"
abPotion["ger"] = "Lethargietrank"

Global( "abBlock",{})
abBlock["rus"] = " " 
abBlock["ger"] = "Hypnose"
abBlock["fra"] = "Lien Mental"
abBlock["eng"] = "Mental Link"
--------------------------------------------------------------------------------
-- CLASS COLORS
--------------------------------------------------------------------------------
Global("ClassColors", {
 ["WARRIOR"]  = { r = 0.65; g = 0.54; b = 0.34; a = 1 },
 ["PALADIN"]  = { r = 0.00; g = 0.88; b = 0.78; a = 1 },
 ["MAGE"]  = { r = 0.18; g = 0.57; b = 1.00; a = 1 },
 ["DRUID"]  = { r = 1.00; g = 0.50; b = 0.00; a = 1 },
 ["PSIONIC"]  = { r = 1.00; g = 0.50; b = 1.00; a = 1 },
 ["STALKER"]  = { r = 0.00; g = 0.78; b = 0.00; a = 1 },
 ["PRIEST"]  = { r = 1.00; g = 1.00; b = 0.31; a = 1 },
 ["NECROMANCER"]  = { r = 0.95; g = 0.17; b = 0.28; a = 1 }
})
--------------------------------------------------------------------------------
-- EVENT HANDLERS
--------------------------------------------------------------------------------

function onDamageReceived(params)
  	if params.target and  params.source then
   		if not unit.IsFriend(params.target) and not unit.IsPlayer(params.target) and UNITS[params.target] then
			if STATUS[params.target] == nil then
				AGRO[params.target] = {TABLE = {}}
				AGRO[params.target].TABLE[params.source]  = 0 
			   	STATUS[params.target] = 1
			end
	
			if AGRO[params.target].TABLE[params.source] == nil then AGRO[params.target].TABLE[params.source] = 0   end
			--------------------
			local k = 1
			local abilka  = userMods.FromWString(params.ability) 
			
			if abViciousSpin[LOC] == abilka then k = 2 end
			if abIncitingShot[LOC] == abilka then k = 2 end
			if abHack[LOC] == abilka then k = 1 end
    			if abHeavenlyNova[LOC] == abilka then 
    				AGRO[params.target].TABLE[params.source] = MaxAgr[params.target]
    				k = 5
    			end
	                if abHatefulBlow[LOC] == abilka then k = 5 end
	                if abWall[LOC]  == abilka then k = 4 end
	                                                                 	
			for i = 0, unit.GetBuffCount(params.target)-1 do
				local Buff = unit.GetBuff(params.target, i )
				if abCondemnation[LOC] == userMods.FromWString(Buff.name)  then
				    if Buff.producer.casterId == params.source then
					--changed by yaro
			 		k = 5
					--/changed by yaro
			 	    end
				end		
			end
	
			for i = 0, unit.GetBuffCount(params.source)-1 do
				local Buff = unit.GetBuff(params.source, i )
				if abHack[LOC] == userMods.FromWString(Buff.name) then k = 1 end

				if abStalwartDefense[LOC] == userMods.FromWString(Buff.name) then
					if Buff.stackCount == 2 then k = k*0.75
   					else  k = k*0.85 end
				end
		
				if abCruelty[LOC] == userMods.FromWString(Buff.name) then k = k * 4 end
			end
	
			if TALANT[params.source] ~= nil then
	 			if TALANT[params.source] == 3 then  k = k*0.80 end
	 			if TALANT[params.source] == 2 then  k = k*0.86 end
	 			if TALANT[params.source] == 1 then  k = k*0.93 end
			end
			if unit.IsPet(params.source) then
				local owner = unit.GetPetOwner(params.source)
				if owner then
					local PlayerClass = unit.GetClass(owner)
					if PlayerClass then
						if PlayerClass.className == "DRUID" and DruidT [owner]  then
							if DruidT [owner]  == 3 then  k = k*1.9 end
							if DruidT [owner]  == 2 then  k = k*1.6 end
							if DruidT [owner]  == 1 then  k = k*1.3 end
						end
						if PlayerClass.className == "NECROMANCER" and userMods.FromWString(object.GetName(params.source)) == stHellion[LOC] and NecromanserT [owner]  then
							if NecromanserT [owner]  == 3 then  k = k*1.3 end
							if NecromanserT [owner]  == 2 then  k = k*1.2 end
							if NecromanserT [owner]  == 1 then  k = k*1.1 end
						end
					end
				end
			end
			 	
			if not object.IsDead(params.source) then AGRO[params.target].TABLE[params.source] = AGRO[params.target].TABLE[params.source]  +( params.amount * k) end
	
			--LogInfo(AGRO[params.target].TABLE[params.source], " ",params.target, " ",params.source )
	   	end
	end


	--------------------

    targetId = avatar.GetTarget()
	if targetId then	
		local faction = unit.GetFaction(targetId)
		--      -    
		if faction and faction.isFriend then	
			targetId = unit.GetTarget(targetId)
			if targetId then faction = unit.GetFaction(targetId)   end
			if faction and faction.isFriend then	
				--   ...   " "  
				targetId = nil
           		end
		end
		if targetId then
			if unit.IsInCombat( targetId ) then
				if not object.IsDead(targetId) then Update(targetId) end
			else
			    HideAllUIElements()
			end
		else
			--     :))
			HideAllUIElements()
		end
	else
		-- 
		HideAllUIElements()
	end
	if not targetId or not AGRO[targetId] then
		SetMainPanelSize(0)
		wtIcon:Show(false)
	end
	if targetId and FAK[targetId] then
		if unit.GetTarget(targetId) ~= FAK[targetId] then 
			FAK[targetId] = {}
			wtIcon:Show(false)
		end 
	end
	
end

-- " "

function Update(targetId)	
	--         .
	local tmpUnSortAgroList = {	MaxAgro = 0	}
	--    index
  	local index = 0
  	local isF = 0
	--    
  	if STATUS[targetId] then
 	--------------------------------------------------------------------------------------------------------
		for i in AGRO[targetId].TABLE do
			if not object.IsExist(i) then AGRO[targetId].TABLE[i] = 0 end 
	  		if AGRO[targetId].TABLE[i] > 0 then
        		index = index + 1
				tmpUnSortAgroList[index] = {
				Agro = AGRO[targetId].TABLE[i],
				Id = i	}
			
				if tmpUnSortAgroList[index].Agro == nil then tmpUnSortAgroList[index].Agro = 0 end
			
				if tmpUnSortAgroList[index].Agro > tmpUnSortAgroList.MaxAgro then
					tmpUnSortAgroList.MaxAgro = tmpUnSortAgroList[index].Agro
					MaxAgr[targetId] = tmpUnSortAgroList.MaxAgro
				end
				
				if FAK[targetId] == i and i then isF = index end

	  		end
    	end
    	if isF and tmpUnSortAgroList[isF] then
    	--LogInfo("!")
    		tmpUnSortAgroList[isF].Agro = tmpUnSortAgroList.MaxAgro+1
    	end
	--------------------------------------------------------------------------------------------------------
   	end
   
	--   
	if index > 1 then	

		-- 
		Sort(tmpUnSortAgroList, index)
		--	
		if index > MAX_AGROLIST_COUNT then index = MAX_AGROLIST_COUNT end
		SetMainPanelSize(index)
		
		if index > MAX_AGROLIST_COUNT then index = MAX_AGROLIST_COUNT end
		local placement = wtMainPanel:GetPlacementPlain()
		placement.sizeY = (index+1) * 20 +40 
		wtMainPanel:SetPlacementPlain(placement)

		wtMainPanel:Show(true)
		
	end
	for i = 1, MAX_AGROLIST_COUNT do	
		if i <= index then	
			--/       
			SetDataToTextView(tmpUnSortAgroList, wtBars[i], wtTexts[i], i, targetId)
			if index > 1 then wtBars[i]:Show(true) end
			if index > 1 then wtTexts[i]:Show(true) end
		else
			-- 
			wtBars[i]:Show(false)
			wtTexts[i]:Show(false)
		end
	end
	
	
	if index > 1 then               -- 1 - archer
		local class = unit.GetClass( tmpUnSortAgroList[1].Id )
		if class then
	  		if unit.GetTarget(targetId) == tmpUnSortAgroList[2].Id and class.className == "STALKER" then
	   				local lukId = tmpUnSortAgroList[1].Id
	 
    	    				if not TALANT[lukId] then
						 TALANT[lukId] = 0
					end
		    	
					TALANT[lukId] = TALANT[lukId] + 1

					if TALANT[lukId] > 3 then TALANT[lukId] = 3 end
					
					if TALANT[lukId] == 3 then  AGRO[targetId].TABLE[lukId] = AGRO[targetId].TABLE[lukId] * 0.912 end
					if TALANT[lukId] == 2 then  AGRO[targetId].TABLE[lukId] = AGRO[targetId].TABLE[lukId] * 0.92 end
                			if TALANT[lukId] == 1 then  AGRO[targetId].TABLE[lukId] = AGRO[targetId].TABLE[lukId] * 0.93 end

	  		end
	 	end
	 	if unit.GetTarget(targetId) == tmpUnSortAgroList[2].Id then
	 		if tmpUnSortAgroList[2].Id and unit.IsPet(tmpUnSortAgroList[2].Id) then
				local owner = unit.GetPetOwner(tmpUnSortAgroList[2].Id)
				local PlayerClass = unit.GetClass(owner)

				if PlayerClass.className and PlayerClass.className == "DRUID" then
	 	    	    		if not DruidT[owner] then
						 DruidT[owner] = 0
					end
					
					if DruidT[owner] > 3 then DruidT[owner] = 3 end
								
					if DruidT[owner] == 3 then  AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] = AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] * 1.18 end
					if DruidT[owner] == 2 then  AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] = AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] * 1.23 end
                			if DruidT[owner] == 1 then  AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] = AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] * 1.3 end		
	 			end
	 			
	 			if PlayerClass.className and PlayerClass.className == "NECROMANCER" and userMods.FromWString(object.GetName(tmpUnSortAgroList[2].Id)) == stHellion[LOC] then
	 	    	    		if not NecromanserT[owner] then
						NecromanserT[owner] = 0
					end
					
					--LogInfo("!!!")
					if NecromanserT[owner] > 3 then NecromanserT[owner] = 3 end
								
					if NecromanserT[owner] == 3 then  AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] = AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] * 1.08 end
					if NecromanserT[owner] == 2 then  AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] = AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] * 1.09 end
                			if NecromanserT[owner] == 1 then  AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] = AGRO[targetId].TABLE[tmpUnSortAgroList[2].Id] * 1.1 end		
	 			end
	 		end
	 	end
	 	
	 	if unit.GetTarget(targetId) and userMods.FromWString(object.GetName(unit.GetTarget(targetId))) == stHellion[LOC] then
	 		if unit.GetTarget(targetId) ~= tmpUnSortAgroList[1].Id then 
	 			FAK[targetId] = unit.GetTarget(targetId)
			
	 		end
	 	end
  	end
end

-- "   "

function SetDataToTextView(data, wtBar, wtText, index, targetId)
 if data[index].Id then
	local PlayerClass = unit.GetClass(data[index].Id)
	local Name = strName[LOC]
	if unit.IsPet(data[index].Id) then
		local petOwnerId = unit.GetPetOwner( data[index].Id )
		if petOwnerId then
 			 Name = userMods.ToWString(userMods.FromWString(object.GetName(data[index].Id)) .. " ( " ..  userMods.FromWString(object.GetName(petOwnerId)) .. " )")
		else
			 Name = userMods.ToWString(userMods.FromWString(object.GetName(data[index].Id)) .. " ( ? )")	
		end
	else
		Name = object.GetName(data[index].Id)
	end
	
	--LogInfo(Name)
	
	if  PlayerClass.className == "WARRIOR"  or PlayerClass.className == "PALADIN" or PlayerClass.className == "MAGE" or PlayerClass.className == "PSIONIC" or PlayerClass.className == "STALKER" or PlayerClass.className == "PRIEST" or PlayerClass.className == "NECROMANCER" then
		wtBar:SetBackgroundColor(ClassColors[PlayerClass.className])
	else
		wtBar:SetBackgroundColor({ r = 1; g = 1; b = 1; a = 1.0 })	
	end
	
	--text %
	wtText:SetVal("INFO", Name)
	if math.mod(data[index].Agro, data.MaxAgro) ~= 0 then
		wtText:SetVal("NUM", common.FormatFloat(data[index].Agro / data.MaxAgro * 100, "%.1f"))
	else
		wtText:SetVal("NUM", common.FormatInt(data[index].Agro / data.MaxAgro * 100, "%d"))	
	end
	--bar %	
	local BarPlace = wtBar:GetPlacementPlain()
	BarPlace.sizeX = data[index].Agro / data.MaxAgro * MAX_BAR_SIZE_X
	wtBar:SetPlacementPlain(BarPlace)

    if  FAK[targetId] == data[index].Id  then--!
		BarPlace.posX = 190
		BarPlace.posY = (index)* 20 + 20  
		BarPlace.sizeX = 18
		wtIcon:SetPlacementPlain(BarPlace)
		wtIcon:Show(true)
 	end
 end

end

-- "     "

function MoveAllUIElementsByForm()	
	local MainPanelPlace = wtMainPanel:GetPlacementPlain()
	local TextPlace = nil
	local BarPlace = nil
	for i = 1, 9 do	
		BarPlace = wtBars[i]:GetPlacementPlain()
		BarPlace.posY = MainPanelPlace.posY + (BarPlace.sizeY + 2) * i + 20
		BarPlace.posX = MainPanelPlace.posX + (MainPanelPlace.sizeX - MAX_BAR_SIZE_X) / 2
		wtBars[i]:SetPlacementPlain(BarPlace)
		TextPlace = wtTexts[i]:GetPlacementPlain()
		TextPlace.posY = MainPanelPlace.posY + (BarPlace.sizeY + 2) * i + 20
		TextPlace.posX = MainPanelPlace.posX + (MainPanelPlace.sizeX - MAX_BAR_SIZE_X) / 2
		wtTexts[i]:SetPlacementPlain(TextPlace)
	end
end

-- "  "

function HideAllUIElements()	
 if not VISIBILITY then 
	wtMainPanel:Show(false)
	FAK = {}
	wtIcon:Show(false)
	for i = 1, 9 do	
		wtBars[i]:Show(false)
		wtTexts[i]:Show(false)
	end
	for i in MaxAgr do
		MaxAgr[i] = nil
	end
 end
end

-- ""

function Sort(data, value)	
	local tempAgro = 0
	local tempId = 0
	for j = 1, value - 1 do	
		for i = 1, value - 1 do	
			if data[i].Agro < data[i + 1].Agro then	
				tempAgro = data[i + 1].Agro
				tempId = data[i + 1].Id
				data[i + 1].Agro = data[i].Agro
				data[i + 1].Id = data[i].Id
				data[i].Agro = tempAgro
				data[i].Id = tempId
			end
		end
	end
end


function onHealingReceived( params )
 if params.healerId and not object.IsFar(params.healerId)  then
 
  if unit.IsInCombat( params.healerId ) and unit.IsFriend(params.healerId) then 

	--------------------------------------------------------------------------------
	
  	local k = 0.25
	local flag = nil
			    
	if params.spellId ~= nil then
	    local s = avatar.GetSpellInfo(params.spellId)
		if s.name  == abEntreaty[LOC] then	flag = 1 end
		if s.name  == abAscension[LOC] then	k= 0.125 end
		if s.name  == abVampirism[LOC] and unit.IsPet(params.unitId) then	k= 0.125 end
	end

   	for i = 0, unit.GetBuffCount(params.healerId)-1 do
		local Buff = unit.GetBuff(params.healerId, i )
		if abCruelty[LOC] == userMods.FromWString(Buff.name) then k = 4 end
 		if abAscension[LOC] == userMods.FromWString(Buff.name) then k = 0.125 end
 		if abStalwartDefense[LOC] == userMods.FromWString(Buff.name) then
			if Buff.stackCountk == 2 then k = k*0.75
   			else  k = k*0.85 end
		end
	end

	for i in AGRO do
	--------------------
			if AGRO[i].TABLE == nil then AGRO[i].TABLE  = {}   end
			if AGRO[i].TABLE[params.healerId] == nil then AGRO[i].TABLE[params.healerId]  = 0  end
	
			
			if flag then
				AGRO[i].TABLE[params.healerId] = AGRO[i].TABLE[params.healerId]  - (params.heal*2)
				if AGRO[i].TABLE[params.healerId] < 0 then AGRO[i].TABLE[params.healerId] = 0 end	
			else
				AGRO[i].TABLE[params.healerId] = AGRO[i].TABLE[params.healerId]  + (params.heal*k)
			end	
	---------------------
	end
  end
 end
end

function onDead( params )
  	if object.IsDead(params.unitId)  then
		if params.unitId == avatar.GetId() then
               		AllDel()
              		HideAllUIElements()
		else
			if STATUS[params.unitId] then
				if AGRO[params.unitId].TABLE then
					for i in AGRO[params.unitId].TABLE do
        			   		AGRO[params.unitId].TABLE[i] = nil
					end
					AGRO[params.unitId].TABLE = nil
  					STATUS[params.unitId] = nil
  					if avatar.GetTarget() ==  targetId  then HideAllUIElements() end
				end
			end
			for x in AGRO do
	  			if STATUS[x] then
        				if AGRO[x].TABLE[params.unitId] then AGRO[x].TABLE[params.unitId] = nil end
				end
			end
			if MaxAgr[params.unitId] then MaxAgr[params.unitId] = nil end
			onDamageReceived({})
		end
	else
		STATUS[params.unitId] = 1	
 	end
end

function onAvatarCombat( params )          --   ()
	if params.inCombat == false then
		for i in UNITS do
		  if UNITS[i] ~= 1 then
			if not unit.IsInCombat( UNITS[i])  and  STATUS[i] then
				for n in AGRO[i].TABLE do
            				AGRO[i].TABLE[n] = nil
				end
				STATUS[i] = nil
				AGRO[i].TABLE = nil			
			end
		  end
		end
	else
		for i in UNITS do
		  if UNITS[i] ~= 1 then
			if unit.IsInCombat( UNITS[i]) and  not STATUS[i] then
				AGRO[i] = {TABLE = {}}
				t = unit.GetTarget(i)
				if t then AGRO[i].TABLE[t] = 1 end
 				STATUS[i] = 1	
			end
		  end	
		end
	end
end

function AllDel( params )
	for x in AGRO do
	    if AGRO[x].TABLE then
		   	for y in AGRO[x].TABLE do
	    	    AGRO[x].TABLE[y] = nil
			end
		end	
		AGRO[x].TABLE = nil
  		STATUS[x] = nil
	end
end


function onBuff( params )
 	local Buff = unit.GetBuff( params.unitId, params.index )

	if Intimidate[LOC] == userMods.FromWString(Buff.name) or Challenge[LOC] == userMods.FromWString(Buff.name) or Provocation[LOC] == userMods.FromWString(Buff.name) and UNITS[params.unitId] then
		--LogInfo(Buff.name)	
		if STATUS[params.unitId] == nil then
			AGRO[params.unitId] = {TABLE = {}}
		 	AGRO[params.unitId].TABLE[Buff.producer.casterId]  = 1 
			STATUS[params.unitId] = 1
		end
		FAK[params.unitId] = Buff.producer.casterId
		if not MaxAgr[params.unitId] then MaxAgr[params.unitId] = 1 end
		AGRO[params.unitId].TABLE[Buff.producer.casterId] = MaxAgr[params.unitId] + 1
	end	

	if abIcyGrave[LOC] == userMods.FromWString(Buff.name)  or abPlague[LOC] == userMods.FromWString(Buff.name)  or  abBlock[LOC] == userMods.FromWString(Buff.name)  or abPotion[LOC] == userMods.FromWString(Buff.name)  then 
		if STATUS[params.unitId] then
			if AGRO[params.unitId].TABLE then
				for i in AGRO[params.unitId].TABLE do
        			   	AGRO[params.unitId].TABLE[i] = nil
				end
				AGRO[params.unitId].TABLE = nil
  				STATUS[params.unitId] = nil
  				if avatar.GetTarget() ==  targetId  then HideAllUIElements() end
			end
			UNITS[params.unitId] = nil
			onDamageReceived({})
		end
	end
end

function onSpawned( params )
	if not unit.IsPet( params.unitId ) and not unit.IsPlayer( params.unitId ) and not unit.IsFriend(  params.unitId ) then
		UNITS[params.unitId] = 1
	end
end

function onDespawned( params )
	if UNITS[params.unitId] then UNITS[params.unitId] = nil end
end

function onA( params )
	local class = unit.GetClass(avatar.GetId())

	if class.className == "STALKER" then
		local talentInfo = avatar.GetFieldTalentInfo( 0, 7, 0 )
		if talentInfo.current then TALANT[avatar.GetId()] = talentInfo.current.rank end
	end 
	if class.className == "NECROMANCER" then
		local talentInfo = avatar.GetFieldTalentInfo( 0, 5, 2 )
		if talentInfo.current then NecromanserT[avatar.GetId()] = talentInfo.current.rank end
	end 
	if class.className == "DRUID" then
		local talentInfo = avatar.GetFieldTalentInfo( 2, 1, 1 )
		if talentInfo.current then DruidT[avatar.GetId()] = talentInfo.current.rank end
	end 

	LOC = GetGameLocalization()
end

function SetMainPanelSize( count )
	local placement = wtMainPanel:GetPlacementPlain()
	placement.sizeY = (count+3) * 20 
	wtMainPanel:SetPlacementPlain(placement)
end
------------ Reactions ---------------------------
function OnDownButtonReaction( params )
	if MAX_AGROLIST_COUNT > 2 then 
		MAX_AGROLIST_COUNT = MAX_AGROLIST_COUNT - 1
		wtCount:SetVal("text", common.FormatInt(MAX_AGROLIST_COUNT, "%d"))	
	end
	for i = MAX_AGROLIST_COUNT+1, 9 do	
		wtBars[i]:Show(false)
		wtTexts[i]:Show(false)
	end
	local tabl = {}
	tabl.count = MAX_AGROLIST_COUNT
	userMods.SetGlobalConfigSection( SECTION_AGROLIST_NAME, tabl )
	if not targetId or not AGRO[targetId] then SetMainPanelSize( 0 ) else SetMainPanelSize( MAX_AGROLIST_COUNT ) end
end

function OnUpButtonReaction( params )
	if MAX_AGROLIST_COUNT < 9 then
		MAX_AGROLIST_COUNT = MAX_AGROLIST_COUNT + 1
		wtCount:SetVal("text", common.FormatInt(MAX_AGROLIST_COUNT, "%d"))
	end
	local tabl = {}
	tabl.count = MAX_AGROLIST_COUNT
	userMods.SetGlobalConfigSection( SECTION_AGROLIST_NAME, tabl )
end
------------ For AddonManager-----------------------
function onAddonManagerMEM( params )
    userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

function onAddonManagerDND( params )
    if params.target == common.GetAddonName() then
	DnD:Enable( wtMainPanel, params.state )
    end
end

function onAddonManagerUI( params )
	mainForm:Show( params.visible )
end

function  SCRIPT_ADDON_INFO_REQUEST( params )
	if params.target == common.GetAddonName() then
		local Desc = "Agrometr - show you aggro" 
		if LOC and LOC == "rus" then Desc = "    "  end
		userMods.SendEvent( "SCRIPT_ADDON_INFO_RESPONSE", {
			sender = params.target,
			desc = Desc,
			showDNDButton = true,
			showHideButton = true
			--showSettingsButton = true,
			--addonsBlocked = { "ContextDamageVisualization" }
			} )
---------------

	end
	
end

function  SCRIPT_TOGGLE_VISIBILITY( params )
	if params.target == common.GetAddonName() then
		VISIBILITY = not VISIBILITY
		if VISIBILITY then 
			mainForm:Show(true)
			wtMainPanel:Show(true)
			if not targetId or not AGRO[targetId] then SetMainPanelSize(0) end
		else
			wtMainPanel:Show(false)		
		end
	end
end
-------------Localization------------------------------

-- AO game Localization detection by SLA. Version 2011-02-10.
function GetGameLocalization()
local B = cartographer.GetMapBlocks()
local T = { rus="\203\232\227\224", eng="Holy Land", ger="Heiliges Land",
fra="Terre Sacr\233e"}      -- , br="Terra Sagrada", jpn="\131\74\131\106\131\65" }
for b in B do for l,t in T do
if userMods.FromWString( cartographer.GetMapBlockInfo(B [b] ).name ) == t
then return l end; end; end; return "eng"
end
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------

function init()
	wtIcon = mainForm:GetChildChecked("Icon", false)

	common.RegisterEventHandler(onA, "EVENT_AVATAR_CREATED")
		if avatar.IsExist() then onA() end
	--     . 
	common.RegisterEventHandler(onDamageReceived, "EVENT_UNIT_DAMAGE_RECEIVED")
	-- hialing
	common.RegisterEventHandler(onHealingReceived, "EVENT_HEALING_RECEIVED")
	--
	common.RegisterEventHandler(onBuff, "EVENT_UNIT_BUFF_ADDED" )
	--
	common.RegisterEventHandler(onAvatarCombat, "EVENT_AVATAR_COMBAT_STATUS_CHANGED")
	--
	common.RegisterEventHandler(onDead, "EVENT_UNIT_DEAD_CHANGED")
	--    -   (  ).
	common.RegisterEventHandler(onDamageReceived, "EVENT_AVATAR_TARGET_CHANGED")
	--        (  ) .
	common.RegisterEventHandler(onDamageReceived, "EVENT_AVATAR_TARGET_TARGET_CHANGED")
	-- [ALT] + [Z]-- toggle ui show/hide
	
	common.RegisterEventHandler(onSpawned, "EVENT_UNIT_SPAWNED" )
	common.RegisterEventHandler(onDespawned, "EVENT_UNIT_DESPAWNED" )
	
	--[ AddonManager
	common.RegisterEventHandler(onAddonManagerMEM, "U_EVENT_ADDON_MEM_USAGE_REQUEST")
	common.RegisterEventHandler(onAddonManagerDND, "U_EVENT_TOGGLE_DND")
	common.RegisterEventHandler(onAddonManagerUI, "SCRIPT_TOGGLE_UI")
	common.RegisterEventHandler( SCRIPT_ADDON_INFO_REQUEST, "SCRIPT_ADDON_INFO_REQUEST" )
	common.RegisterEventHandler( SCRIPT_TOGGLE_VISIBILITY, "SCRIPT_TOGGLE_VISIBILITY" )
	--common.RegisterEventHandler( SCRIPT_SHOW_SETTINGS, "SCRIPT_SHOW_SETTINGS" )
	-- ]--
	
	wtMainPanel = mainForm:GetChildChecked("MainPanel", false)
	wtPlayer1Bar = wtMainPanel:GetChildChecked("Player1Bar", false)
	wtTextView = wtMainPanel:GetChildChecked("TextView", false)

	wtDanger = wtMainPanel:GetChildChecked("Danger", false)
	wtUp = wtMainPanel:GetChildChecked("UpButton", false)
	wtDown = wtMainPanel:GetChildChecked("DownButton", false)
	wtCount = wtMainPanel:GetChildChecked("Count", false)
	
	common.RegisterReactionHandler(OnDownButtonReaction, "DownButtonReaction")
	common.RegisterReactionHandler(OnUpButtonReaction, "UpButtonReaction")
	
	wtTextView:Show(false)
	wtPlayer1Bar:Show(false)
	wtMainPanel:Show(false)
	
	local tabl  = userMods.GetGlobalConfigSection( SECTION_AGROLIST_NAME )
	if tabl and tabl.count then MAX_AGROLIST_COUNT = tabl.count else MAX_AGROLIST_COUNT = 5 end
	
	--  
	for i = 1, 9 do	
		wtBars[i] = mainForm:CreateWidgetByDesc(wtPlayer1Bar:GetWidgetDesc())
		wtTexts[i] = mainForm:CreateWidgetByDesc(wtTextView:GetWidgetDesc())
	end
	wtCount:SetVal("text", common.FormatInt(MAX_AGROLIST_COUNT, "%d"))
	wtDanger:SetVal("text", userMods.ToWString("  RealAgroM "))
	
	

	
	--  movable :)
	DnD:Init( 592, wtMainPanel, mainForm, true )
	--  
	HideAllUIElements()
	--   
	MoveAllUIElementsByForm()

end

--------------------------------------------------------------------------------
init()
--------------------------------------------------------------------------------
